program gmp_test;
 
{$mode objfpc}{$H+}
 
uses
  SysUtils, gmp;
  
  function factorial(num:longint):ansistring ; {standalone}
   type
     AT = array[0..99] of longint;
     var
     _mod,_div:at;
     fact,a,b,c:ansistring;
       pa,pb,pc:pchar;
     n,carry,ai:smallint;
    la,lb,i,j,z:longint;

      begin {create lookup  tables}
     for z:=0 to 99 do
     begin
     _mod[z]:= (z mod 10) +48;
     _div[z]:=  z div 10;
      end;  {created lookup tables}

       fact:='1';
      for z:=1 to num do
         begin
       a:=fact;Str(z,b);la:=Length(a);lb:=length(b);
       Setlength(c,la+lb);
       FillChar(c[1],la+lb,#48);
        pa:=@a[1]; {set pointers }
        pb:=@b[1];
        pc:=@c[1];
      for i:=la-1 downto 0 do
      begin
         carry:=0;ai:=ord(pa[i])-48 ;
      for j:= lb-1 downto 0 do
      begin
        n :=ai*(ord(pb[j])-48)+(ord(pc[i+j+1])-48)+carry;
        carry :=_Div[n];ord(pc[i+j+1]):=_Mod[n];
      end; {next j}
       ord(pc[i]):=ord(pc[i])+carry ;
      end; {next i}
      fact:=c;
      if c[1]='0' then fact:=copy(c,2,length(c)-1) ;
      end;{next z}
       factorial:=fact;
      end;{function}
  
var
  f: MPInteger;
    e:ansistring;
      num:integer;
     t:int64;
begin
  t:=gettickcount;
  f :=  z_fac_ui(1000);
  t:=gettickcount-t;
  WriteLn(string(f),#10,'time taken gmp = ',t);
  t:=gettickcount;
  e :=  factorial(1000);
  t:=gettickcount-t;
   WriteLn(e,#10,'time taken non gmp = ',t);
  
readln;
end.
 
